Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private m_XMLFile As String
        Private m_RootNode As Node

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents picNetwork As System.Windows.Forms.PictureBox
    Friend WithEvents txtSerialization As System.Windows.Forms.TextBox
    Friend WithEvents btnDeserialize As System.Windows.Forms.Button
    Friend WithEvents btnSerialize As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picNetwork = New System.Windows.Forms.PictureBox()
        Me.txtSerialization = New System.Windows.Forms.TextBox()
        Me.btnSerialize = New System.Windows.Forms.Button()
        Me.btnDeserialize = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'picNetwork
        '
        Me.picNetwork.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picNetwork.Name = "picNetwork"
        Me.picNetwork.Size = New System.Drawing.Size(264, 264)
        Me.picNetwork.TabIndex = 0
        Me.picNetwork.TabStop = False
        '
        'txtSerialization
        '
        Me.txtSerialization.Location = New System.Drawing.Point(352, 0)
        Me.txtSerialization.Multiline = True
        Me.txtSerialization.Name = "txtSerialization"
        Me.txtSerialization.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtSerialization.Size = New System.Drawing.Size(160, 72)
        Me.txtSerialization.TabIndex = 2
        Me.txtSerialization.Text = ""
        '
        'btnSerialize
        '
        Me.btnSerialize.Location = New System.Drawing.Point(272, 64)
        Me.btnSerialize.Name = "btnSerialize"
        Me.btnSerialize.Size = New System.Drawing.Size(72, 24)
        Me.btnSerialize.TabIndex = 3
        Me.btnSerialize.Text = "Serialize"
        '
        'btnDeserialize
        '
        Me.btnDeserialize.Location = New System.Drawing.Point(272, 112)
        Me.btnDeserialize.Name = "btnDeserialize"
        Me.btnDeserialize.Size = New System.Drawing.Size(72, 24)
        Me.btnDeserialize.TabIndex = 3
        Me.btnDeserialize.Text = "Deserialize"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(536, 264)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnSerialize, Me.btnDeserialize, Me.txtSerialization, Me.picNetwork})
        Me.Name = "Form1"
        Me.Text = "SerializeNetworkBinary"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Build a small network.
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim nodeA As Node
        Dim nodeB As Node
        Dim nodeC As Node
        Dim nodeD As Node
        Dim nodeE As Node
        Dim nodeF As Node

        ' Compose the data file name.
        m_XMLFile = DataSubdirectory() & "\Network.xml"

        nodeA = New Node(160, 20, "A")
        nodeB = New Node(20, 80, "B")
        nodeC = New Node(140, 140, "C")
        nodeD = New Node(240, 140, "D")
        nodeE = New Node(60, 240, "E")
        nodeF = New Node(240, 240, "F")
        m_RootNode = nodeA

        With nodeA
            ReDim .Neighbors(1)
            .Neighbors(0) = nodeB
            .Neighbors(1) = nodeD
        End With
        With nodeB
            ReDim .Neighbors(2)
            .Neighbors(0) = nodeA
            .Neighbors(1) = nodeC
            .Neighbors(2) = nodeE
        End With
        With nodeC
            ReDim .Neighbors(3)
            .Neighbors(0) = nodeB
            .Neighbors(1) = nodeD
            .Neighbors(2) = nodeE
            .Neighbors(3) = nodeF
        End With
        With nodeD
            ReDim .Neighbors(2)
            .Neighbors(0) = nodeA
            .Neighbors(1) = nodeC
            .Neighbors(2) = nodeF
        End With
        With nodeE
            ReDim .Neighbors(2)
            .Neighbors(0) = nodeB
            .Neighbors(1) = nodeC
            .Neighbors(2) = nodeF
        End With
        With nodeF
            ReDim .Neighbors(2)
            .Neighbors(0) = nodeC
            .Neighbors(1) = nodeD
            .Neighbors(2) = nodeE
        End With
    End Sub

    ' Draw the network.
    Private Sub picNetwork_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picNetwork.Paint
        ' Draw the network.
        DrawNetwork(e.Graphics)
    End Sub

    ' Draw the network.
    Private Sub DrawNetwork(ByVal gr As Graphics)
        ' Clear the picture.
        gr.Clear(picNetwork.BackColor)
        If m_RootNode Is Nothing Then Exit Sub

        ' Draw the links.
        DrawNetworkPart(gr, m_RootNode, True)
        m_RootNode.UnmarkNodes()

        ' Draw the nodes.
        DrawNetworkPart(gr, m_RootNode, False)
        m_RootNode.UnmarkNodes()
    End Sub

    ' Draw the network's nodes or links.
    Private Sub DrawNetworkPart(ByVal gr As Graphics, ByVal root_node As Node, ByVal draw_links As Boolean)
        Dim link_num As Integer

        If root_node.Visited Then Exit Sub
        root_node.Visited = True

        ' Draw the node/links for this node.
        If draw_links Then
            root_node.DrawLinks(gr)
        Else
            root_node.DrawNode(gr)
        End If

        ' Make the neighbos draw their nodes/links.
        For link_num = root_node.Neighbors.GetLowerBound(0) To root_node.Neighbors.GetUpperBound(0)
            DrawNetworkPart(gr, root_node.Neighbors(link_num), draw_links)
        Next link_num
    End Sub

    ' Make the serialization area as large as possible.
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim wid As Integer

        wid = ClientSize.Width - txtSerialization.Location.X
        If wid < 10 Then wid = 10
        txtSerialization.SetBounds(txtSerialization.Location.X, 0, wid, ClientSize.Height)
    End Sub

    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Cursor = Cursors.WaitCursor
        txtSerialization.Text = ""
        Refresh()

        ' Create a new BinaryFormatter.
        Dim binary_formatter As New BinaryFormatter()

        ' Create a FileStream to write with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Create)

        ' Serialize m_RootNode.
        binary_formatter.Serialize(file_stream, m_RootNode)

        ' Close the FileStream.
        file_stream.Close()

        ' Display the results.
        txtSerialization.Text = "<Binary file>"

        ' Clear the network.
        m_RootNode = Nothing
        DrawNetwork(picNetwork.CreateGraphics())

        Cursor = Cursors.Default
    End Sub

    Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
        Cursor = Cursors.WaitCursor
        picNetwork.CreateGraphics.Clear(picNetwork.BackColor)
        Refresh()

        ' Create a new BinaryFormatter.
        Dim binary_formatter As New BinaryFormatter()

        ' Create a FileStream to read with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Open)

        ' Read the item from the serialization.
        m_RootNode = CType(binary_formatter.Deserialize(file_stream), Node)
        file_stream.Close()

        ' Display the network.
        DrawNetwork(picNetwork.CreateGraphics())

        ' Clear the serialization text.
        txtSerialization.Text = ""

        Cursor = Cursors.Default
    End Sub
End Class
